/***********************************************************************************************************
Copyright (c) 2012, Sebastian Breß, Otto-von-Guericke University of Magdeburg, Germany. All rights reserved.

This program and accompanying materials are made available under the terms of the 
GNU LESSER GENERAL PUBLIC LICENSE - Version 3, http://www.gnu.org/licenses/lgpl-3.0.txt
***********************************************************************************************************/
#pragma once

#include <time.h>
#include <sys/timeb.h>
#include <stdint.h>
#include <vector>
// needs -lrt (real-time lib)
// 1970-01-01 epoch UTC time, 1 mcs resolution (divide by 1M to get time_t)

namespace hype{
	namespace core{


class EstimatedTime{

	public:
	EstimatedTime();
	explicit EstimatedTime(double time_in_nanoseconds);

	double getTimeinNanoseconds() const;

	private:
	 double value_in_nanoseconds_;

}; 

class MeasuredTime{

	public:
	MeasuredTime();
	explicit MeasuredTime(double time_in_nanoseconds);

	double getTimeinNanoseconds() const;

	private:
	 double value_in_nanoseconds_;

}; 

typedef std::vector<double> Tuple;

uint64_t getTimestamp();

//uint64_t getTimestamp()
//{
//    timespec ts;
//    //clock_gettime(CLOCK_REALTIME, &ts);
//    //return (uint64_t)ts.tv_sec * 1000000LL + (uint64_t)ts.tv_nsec / 1000LL;
//    clock_gettime(CLOCK_REALTIME, &ts);
// 	 return (uint64_t)ts.tv_sec * 1000000000LL + (uint64_t)ts.tv_nsec;
//}

	}; //end namespace core
}; //end namespace stemod

