
#pragma once

#include <iostream>
#include <string>
#include <vector>
#include <tr1/memory>

//loki library
#include <loki/Singleton.h>
#include <loki/Factory.h>

//STEMOD includes
#include <core/recomputation_heuristic.hpp>
#include <core/time_measurement.hpp>

namespace hype{
	namespace core{

	class PeriodicRecomputation : public RecomputationHeuristic {
		
		public:
		PeriodicRecomputation();
		/*! returns true, if approximation function has to be recomputed and false otherwise*/
		virtual bool internal_recompute(Algorithm& algortihm);

		static RecomputationHeuristic* create(){
			return new PeriodicRecomputation();
		}

		private:
		unsigned int counter_;
	};

	}; //end namespace core
}; //end namespace stemod


