
#pragma once

#include <iostream>
#include <string>
#include <vector>
#include <tr1/memory>

#include <core/statistical_method.hpp>
#include <core/time_measurement.hpp>

//alglib includes
#include <interpolation.h>

namespace hype{
	namespace core{

class Least_Squares_Method_1D : public StatisticalMethod {

public:
	Least_Squares_Method_1D(); 
//: StatisticalMethod("Least Squares 1D") {
//		 StatisticalMethodFactorySingleton::Instance()
//	}

	virtual const EstimatedTime computeEstimation(const Tuple& input_values);

	virtual bool recomuteApproximationFunction(Algorithm& algorithm);

	virtual bool inTrainingPhase() const throw();

	virtual void retrain();

//	static Least_Squares_Method_1D* create();

	static Least_Squares_Method_1D* create(){
		return new Least_Squares_Method_1D();
	}

	virtual ~Least_Squares_Method_1D();

private:
		alglib::barycentricinterpolant timeestimationpolynomial_;
		unsigned int degree_of_polynomial_;
		bool polynomial_computed_;
};

//factory function
//const std::tr1::shared_ptr<StatisticalMethod> getStatisticalMethodbyName(std::string name);

//typedef Loki::Factory< StatisticalMethod, std::string> StatisticalMethodFactory; //aFactory;
//typedef Loki::Singleton<StatisticalMethodFactory> StatisticalMethodFactorySingleton;


	}; //end namespace core
}; //end namespace stemod

