
#pragma once

//#include <core/scheduling_decision.hpp>

//#include <boost/shared_ptr.hpp>

#include <query_processing/typed_operator.hpp>
#include <query_processing/unary_operator.hpp>
#include <query_processing/binary_operator.hpp>

namespace hype
{
	namespace queryprocessing
	{
		template <typename Type>
		class PhysicalQueryPlan
		{		public:
				typedef typename OperatorMapper_Helper_Template<Type>::TypedOperatorPtr TypedOperatorPtr;
				typedef typename OperatorMapper_Helper_Template<Type>::TypedNodePtr TypedNodePtr;
				typedef typename OperatorMapper_Helper_Template<Type>::PhysicalQueryPlanPtr PhysicalQueryPlanPtr;
				//typedef typename OperatorMapper_Helper_Template<Type>::TypedOperator TypedOperator;

			PhysicalQueryPlan(TypedOperatorPtr root) : root_(root){
				
			}
			
			bool run(){
				if(root_)
					return root_->run();
				else
					return false;
			}
			
			const Type getResult(){
				return root_->getResult();
			}
			
			/*
			template <typename CallableType>
			void reverse_level_order(CallableType f){
					
			}*/
			
			//copy
			//print
			void print(){
				std::cout << "PhysicalQueryPlan:" << std::endl;
				root_->print();
			}
			
			private:
			TypedOperatorPtr root_;
		};

		//typedef boost::shared_ptr<PhysicalQueryPlan> PhysicalQueryPlanPtr;

	}; //end namespace queryprocessing
}; //end namespace stemod
