

#pragma once

//#include <core/scheduling_decision.hpp>

//#include <boost/shared_ptr.hpp>

#include <query_processing/typed_operator.hpp>

namespace hype
{
	namespace queryprocessing
	{
		template <typename OperatorInputType,typename OperatorOutputType> //, typename TLogicalOperation>
		class UnaryOperator : public TypedOperator<OperatorOutputType>{ //uses 1D Learning Method
			
		public:
			//typedef typename OperatorMapper_Helper_Template<OperatorOutputType>::TypedOperator TypedOperator;
			typedef typename OperatorMapper_Helper_Template<OperatorOutputType>::TypedOperatorPtr TypedOperatorPtr;
			//typedef typename OperatorMapper_Helper_Template<OperatorOutputType>::TypedNodePtr TypedNodePtr;		
		
			//typedef TLogicalOperation LogicalOperationType;
			UnaryOperator(const hype::SchedulingDecision& sched_dec, TypedOperatorPtr child)
			 : TypedOperator<OperatorOutputType>(sched_dec), child_(child){}

			virtual ~UnaryOperator(){}

			OperatorInputType getInputData(){
				if(child_)
					return child_->getResult();
				else
					return OperatorInputType();
			}
			
			virtual bool run(){
				
				if(child_){
					child_->run();
				}
				//execute this operator
				return (*this)();
			}
	
			virtual void print(unsigned int tree_level) const{
				for(unsigned int i=0;i<tree_level;++i){
					std::cout << "\t";
				}
				assert(!this->getFeatureValues().empty());
				std::cout << this->getAlgorithmName() << " Cost: " << this->getEstimatedExecutionTime().getTimeinNanoseconds() 
							 << "\tEstimated Cardinality of Input Data: " << this->getFeatureValues()[0]
							 << std::endl; // << " Features: " << this->getFeatureValues() << std::endl;
				if(child_) child_->print(tree_level+1);
			}
			

	
			/*
			virtual std::list<TypedOperator<OperatorOutputType>& > getOperatorQueue(){				
				std::list<TypedOperator<OperatorOutputType>& > list = child_->getOperatorQueue();
				list.push_front(*this);
				return list;	
			}*/

			boost::shared_ptr<TypedOperator<OperatorInputType> > child_;
			//boost::shared_ptr<TypedOperator<OperatorOutputType> > succsessor_;
		};
		
	}; //end namespace queryprocessing
}; //end namespace stemod
