
#include <query_processing/operator.hpp>

#include <hype.hpp>

namespace hype
{
	namespace queryprocessing
	{

		bool Operator::operator() ()
		{
			bool ret=false;
			//try{
			if(!hype::core::quiet && hype::core::verbose && hype::core::debug)
				std::cout << "[Operator] Executing "
				          //<< sched_dec_.getNameofChoosenAlgorithm()
				          << std::endl;
			hype::AlgorithmMeasurement alg_measure(sched_dec_);
			//call user defined execution function
			ret = execute();
			alg_measure.afterAlgorithmExecution();
			return ret;
		}

		const hype::core::SchedulingDecision& Operator::getSchedulingDecision() const throw(){
				return this->sched_dec_;
		}

		Operator::~Operator() {}

		Operator::Operator(const hype::SchedulingDecision& sched_dec) : sched_dec_(sched_dec) {}


		const core::EstimatedTime Operator::getEstimatedExecutionTime() const throw(){
			return sched_dec_.getEstimatedExecutionTimeforAlgorithm();
		}
		
		const std::string Operator::getAlgorithmName() const throw(){
			return sched_dec_.getNameofChoosenAlgorithm();
		}


		const core::Tuple Operator::getFeatureValues() const throw(){
			return sched_dec_.getFeatureValues();
		}	
		
		ComputeDevice Operator::getComputeDevice() const throw(){
			return sched_dec_.getComputeDevice();
		}	


	}; //end namespace queryprocessing
}; //end namespace stemod
