
#include <core/scheduling_decision.hpp>
#include <core/algorithm.hpp>

#include <typeinfo>
#include <iostream>

namespace hype{
	namespace core{

	/*
	SchedulingDecision::SchedulingDecision(const std::string& name_of_algorithm,
														const EstimatedTime& estimated_time_for_algorithm, 
														const Tuple& feature_values)
														: name_of_algorithm_(name_of_algorithm), 
														  estimated_time_for_algorithm_(estimated_time_for_algorithm),
														  feature_values_(feature_values)
	{

	}*/
	
		SchedulingDecision::SchedulingDecision(Algorithm& alg_ref,
														const EstimatedTime& estimated_time_for_algorithm, 
														const Tuple& feature_values)
														: //name_of_algorithm_(name_of_algorithm),
														  alg_ref_(alg_ref),
														  estimated_time_for_algorithm_(estimated_time_for_algorithm),
														  feature_values_(feature_values)
	{
		alg_ref.incrementNumberofDecisionsforThisAlgorithm();
	}
	
	SchedulingDecision::~SchedulingDecision(){
			//std::cout << "Ich geh dann mal... " << typeid(SchedulingDecision).name() << std::endl;
	}

	const std::string SchedulingDecision::getNameofChoosenAlgorithm() const{
		//return name_of_algorithm_;
		return alg_ref_.getName();
	}

	const EstimatedTime SchedulingDecision::getEstimatedExecutionTimeforAlgorithm() const{
		return estimated_time_for_algorithm_;
	}

	const Tuple SchedulingDecision::getFeatureValues() const{
		return feature_values_;
	}
	
	ComputeDevice SchedulingDecision::getComputeDevice() const throw(){
		return alg_ref_.getComputeDevice();
	}

	}; //end namespace core
}; //end namespace stemod

