
#include <core/time_measurement.hpp>

namespace hype{
	namespace core{

	EstimatedTime::EstimatedTime() : value_in_nanoseconds_(-1){

	}

	EstimatedTime::EstimatedTime(double time_in_nanoseconds) : value_in_nanoseconds_(time_in_nanoseconds){

	}

	double EstimatedTime::getTimeinNanoseconds() const{
		return value_in_nanoseconds_;
	}

	MeasuredTime::MeasuredTime() : value_in_nanoseconds_(-1){

	}

	MeasuredTime::MeasuredTime(double time_in_nanoseconds) : value_in_nanoseconds_(time_in_nanoseconds){

	}

	double MeasuredTime::getTimeinNanoseconds() const{
		return value_in_nanoseconds_;
	}

	uint64_t getTimestamp()
	{
    timespec ts;
    //clock_gettime(CLOCK_REALTIME, &ts);
    //return (uint64_t)ts.tv_sec * 1000000LL + (uint64_t)ts.tv_nsec / 1000LL;
    clock_gettime(CLOCK_REALTIME, &ts);
 	 return (uint64_t)ts.tv_sec * 1000000000LL + (uint64_t)ts.tv_nsec;
	}

	}; //end namespace core
}; //end namespace stemod

